//Reserva de mem de modo dinmico: malloc(). Amplia memoria reservada mediante
//funcin  realloc();
/**********Realizado por Ismael Camarero Sanz*************/
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include "string.h"

void main()
{
	const int BYTES = 40;
	char *p;
	clrscr();

	//Asignar espacio para una cadena de caracteres//
	p = (char *)malloc (BYTES *sizeof(char));

	//Copiar la cadena de caracteres en el espacio asignado//
	strcpy (p, "*abcdef");

	//Reasignar el bloque para que pueda contener ms caracteres//
	if ((p !=NULL))
	     p=(char*) realloc (p, BYTES * 2 *sizeof(char));

	if ((p !=NULL))
	{
		printf("Bloque reasignado\n");
		//Escrbir la cadena original//
		printf ("%s\n",p);
		//Liberar el espacio de memeoria//
		free(p);
		printf("\n El bloque ha sido liberado\n");
	}
	else
	{
		printf ("La reasignacin no ha sido posible\n");
		printf ("El espacio ocupado por el bloque ha sido liberado");
	}
	getch();
}

